--
-- Patterns for digicode
--

  in  ck    B;  
  in  jour  B;
  in  reset B; 
  in  i (3 downto 0) X;;
  out porte B;
  out alarm B;
  out ep_0  B;
  out ep_1  B;
  out ep_2  B;
  out ep_3  B;
  out ep_4  B;
  out ep_5  B;
  out ep_a  B;

  register circuit.cs(2 downto 0) X;;

begin

-- Pattern description :


--  c j r i  p  a  e  e  e  e  e  e  e  c
--  k o e    o  l  p  p  p  p  p  p  p  s
--    u s    r  a  0  1  2  3  4  5  a
--    r e    t  r
--      t    e  m

-- Reset

  : 0 1 1 0 ?* ?* ?* ?* ?* ?* ?* ?* ?* ?*;
  : 1 1 1 0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;

-- Press f

  : 0 1 0 f ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;
  : 1 1 0 f ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?1 ?0 ?*;

-- Reset

  : 0 1 1 0 ?* ?* ?* ?* ?* ?* ?* ?* ?* ?*;
  : 1 1 1 0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;

-- Press 5

  : 0 1 0 5 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;
  : 1 1 0 5 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?*;

-- Press 3

  : 0 1 0 3 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?*;
  : 1 1 0 3 ?0 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?*;

-- Press c

  : 0 1 0 c ?0 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?*;
  : 1 1 0 c ?0 ?0 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?*;

-- Press 1

  : 0 1 0 1 ?0 ?0 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?*;
  : 1 1 0 1 ?0 ?0 ?0 ?0 ?0 ?0 ?1 ?0 ?0 ?*;

-- Press 7

  : 0 1 0 7 ?0 ?0 ?0 ?0 ?0 ?0 ?1 ?0 ?0 ?*;
  : 1 1 0 7 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?1 ?0 ?*;

-- Reset

  : 0 1 1 0 ?* ?* ?* ?* ?* ?* ?* ?* ?* ?*;
  : 1 1 1 0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;

-- Press 2

  : 0 1 0 2 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;
  : 1 1 0 2 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;

-- Press 5

  : 0 1 0 5 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;
  : 1 1 0 5 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?*;

-- Press 4

  : 0 1 0 4 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?*;
  : 1 1 0 4 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;

-- Reset

  : 0 1 1 0 ?* ?* ?* ?* ?* ?* ?* ?* ?* ?*;
  : 1 1 1 0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;

-- Press F

  : 0 0 0 f ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;
  : 1 0 0 f ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?1 ?*;

-- Reset

  : 0 1 1 0 ?* ?* ?* ?* ?* ?* ?* ?* ?* ?*;
  : 1 1 1 0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;

-- Press 5

  : 0 0 0 5 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;
  : 1 0 0 5 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?*;

-- Press 3

  : 0 0 0 3 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?*;
  : 1 0 0 3 ?0 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?*;

-- Press C

  : 0 0 0 c ?0 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?*;
  : 1 0 0 c ?0 ?0 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?*;

-- Press 1

  : 0 0 0 1 ?0 ?0 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?*;
  : 1 0 0 1 ?0 ?0 ?0 ?0 ?0 ?0 ?1 ?0 ?0 ?*;

-- Press 7

  : 0 0 0 7 ?0 ?0 ?0 ?0 ?0 ?0 ?1 ?0 ?0 ?*;
  : 1 0 0 7 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?1 ?0 ?*;

-- Reset

  : 0 1 1 0 ?* ?* ?* ?* ?* ?* ?* ?* ?* ?*;
  : 1 1 1 0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;

-- Press 2

  : 0 0 0 2 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;
  : 1 0 0 2 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?1 ?*;

-- Reset

  : 0 1 1 0 ?* ?* ?* ?* ?* ?* ?* ?* ?* ?*;
  : 1 1 1 0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;

-- Press 5

  : 0 0 0 5 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;
  : 1 0 0 5 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?*;

-- Reset

  : 0 1 1 0 ?* ?* ?* ?* ?* ?* ?* ?* ?* ?*;
  : 1 1 1 0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;

-- Press 5

  : 0 0 0 5 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?0 ?*;
  : 1 0 0 5 ?0 ?0 ?0 ?1 ?0 ?0 ?0 ?0 ?0 ?*;
 
end;
