%!
% Up to 35 signals could be displayed with the default setup
% What about display width?

%Set the default font
/Times-Roman findfont
8 scalefont
setfont

%Set the default line width
0 setlinewidth

%separation between vertical lines inside the wave box
/grid_separation 62 def

%Height of the wave box
/grid_height 530 def

%Separation between signals (center to center)
/sig_separation 15 def

%Define the left margin of the page
/left_margin 36 def

%Define the default height of the signals
/height 10 def

%Define the transition length of the vectors
/tran_len 2 def

%Define x coord of the right edge of the sinal name 
/sig_name_redge 108 def

% Display a single line in the horizintal direction
/line {
	0 rlineto
} def

% Display a transition from low to high.
/pos_edge {
	0 height rlineto
} def

% Display a transition from high to low.
/neg_edge {
	0 0 height sub rlineto
} def

% Function to display a vector. Requires a length and a string
/bus_line {
	/mesg exch def
	/xlen exch def
	xlen 0 rlineto
        gsave
	xlen 4 sub mesg stringwidth pop
        gt { 2 xlen sub 2 rmoveto mesg show } if
	grestore
	xlen 0 exch sub height rmoveto
	xlen 0 rlineto
	0 0 height  sub rmoveto
} def

%Create the lines to indicata bus change.
/bus_change {
	tran_len height rlineto
	0 tran_len sub 0 rmoveto
	tran_len 0 height sub rlineto

} def

%Put the name of the signal on the left of the wave box
/sig_name {
	gsave
	/name exch def
	/init exch def
	/Times-Roman findfont
	10 scalefont
	setfont
	%move string lentgth to the left. If too far part of signal chopped
	0 name stringwidth pop sub tran_len sub
	1 rmoveto
        name show
	/Times-Roman findfont
	8 scalefont
	setfont
	grestore
	init 0 gt {0 height rmoveto} if
} def
/bus_name {
	gsave
	/name exch def
	/Times-Roman findfont
	10 scalefont
	setfont
	%move string lentgth to the left. If too far part of signal chopped
	0 name stringwidth pop sub tran_len sub
	1 rmoveto
        name show
	/Times-Roman findfont
	8 scalefont
	setfont
	grestore
} def

%Adjust coordinates for new signal
/new_sig {
	sig_separation 0 rmoveto
} def	


%Generate a boxed grid
gsave 
[2] 0 setdash
left_margin left_margin sig_name_redge add grid_separation sub moveto
0 1 10{
	0 grid_separation rmoveto
	gsave
	grid_height 0 rlineto pop
	stroke
	grestore 

} for
0 0 grid_separation 10 mul sub rlineto
grid_height 0 rmoveto
0 grid_separation 10 mul rlineto
stroke
grestore

%Move to the top of the wave grid
left_margin left_margin sig_name_redge add moveto
