#include <iostream.h>
#include <string.h>

#ifndef _STRING
#define _STRING

class string
{
public:
  string() : BufferLen( -1 ), Buffer( EmptyString ), ActualLen( 0 ) {}
  string( int Length );
  string( const char *Rhs );
  string( const string & Rhs );
  string( char Rhs );
  
  virtual ~string() { if ( BufferLen != -1 ) delete []  Buffer; }
  
  int len( void ) const { return ActualLen; }
  int strstr( string &subStr ) const
    { return ( ::strstr( Buffer, subStr.getBuffer() ) ) ? 1 : 0; }
  int strstr( const char *subStr ) const
    { return ( ::strstr( Buffer, subStr ) ) ? 1 : 0; }

  const string & operator=( const string & Rhs );
  const string & operator=( const char *Rhs );
  const string & operator=( char Rhs );
  
  const string & operator+=( const string & Rhs );
  const string & operator+=( const char *Rhs );
  const string & operator+=( char Rhs );
  
  string operator+( const string & Rhs ) const;
  string operator+( const char *Rhs ) const;
  string operator+( char Rhs ) const;
  
  const string & operator*=( int Int );
  string operator*( int Int ) const;
  
  virtual char operator[]( int Index ) const;
  char & operator[]( int Index );
  
  string operator()( int Ind1, int Ind2 ) const;    
  
  char *getBuffer() const { return Buffer; }
  //operator char *() { return Buffer; }
  
  int operator!() const { return ActualLen == 0; }
  friend int operator==( const string &Lhs, const string &Rhs );
  friend int operator!=( const string &Lhs, const string &Rhs );
  friend int operator>=( const string &Lhs, const string &Rhs );
  friend int operator<=( const string &Lhs, const string &Rhs );
  friend int operator>( const string &Lhs, const string &Rhs );
  friend int operator<( const string &Lhs, const string &Rhs );
  
  friend ostream & operator<<( ostream &os, const string &Str );
  friend istream & operator>>( istream &is, string &Str );
  
protected:
  char *Buffer;
  int BufferLen, ActualLen;
  static char *EmptyString;
};

typedef string ZString;

class stringTokenizer
{
public:
  stringTokenizer();
  stringTokenizer( const string &str );
  ~stringTokenizer() { delete [] stringVar; }
  
  void set( const string &str );
  string next( const string &separator );
  
private:
  char *stringVar;
  int isFirst;
  int valid;
  
  stringTokenizer & operator=( const stringTokenizer & );
};

#endif


