/////////////////////////////////////////////////////////////////////////
// $Source: /home/mzini/waview/RCS/waview.C,v $
// $Revision: 1.18 $
/////////////////////////////////////////////////////////////////////////

#include <forms.h>
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <limits.h>

#include "string.hh"
#include "signal.hh"
#include "waview.hh"

#include "open.xpm"
#include "save.xpm"
#include "tools.xpm"
#include "ptools.xpm"
#include "busp.xpm"
#include "bus2p.xpm"
#include "sigp.xpm"
#include "cut.xpm"
#include "copy.xpm"
#include "paste.xpm"

App::App( int argc, char **argv )
{
  FL_OBJECT *obj;

  if ( argc >= 2 )
  {
    if ( argv[ 1 ][ 0 ] != '-' )
      startFile = argv[ 1 ];
    else
      startFile = "";
  }
  parseIniFile( HOME );
  parseIniFile( LOCAL );

  fl_initialize( &argc, argv, "general", 0, 0 );

  // Initialize properties dialog
  propForm = new SignalTypeForm( this );
  // Initialize about dialog
  aboutForm = new AboutForm( this );
  // Initialize program properties dialog
  progPropForm = new ProgramPropertiesForm( this );

  button1 = 0;
  button2 = 0;
  button3 = 0;

  numSignals = 0;
  numSamples = 0;
  startSample = 0;
  startSignal = 0;

  sigNameWidth = iniStruct.SignalNameWidth;
  cursorPos1 = sigNameWidth;
  selectedSample = 0;

  selectedSignal = -1;

  moveDivider = 0;
  zoomBoxOn = 0;

  tempCutSig = NULL;
  tempCopySig = NULL;

  unsigned w = 9, h = 9;
  FL_COLOR dummy;
  busPix = fl_create_from_pixmapdata( fl_default_window(), busp_xpm, &w, &h, NULL, 
				      0, 0, dummy );
  bus2Pix = fl_create_from_pixmapdata( fl_default_window(), bus2p_xpm, &w, &h, NULL, 
				       0, 0, dummy );
  sigPix = fl_create_from_pixmapdata( fl_default_window(), sigp_xpm, &w, &h, NULL, 
				      0, 0, dummy );

  fl_set_border_width( -2 );

  mainWindow = fl_bgn_form( FL_FLAT_BOX, iniStruct.MainWindowWidth, 
			    iniStruct.MainWindowHeight );

  mainBox = fl_add_box( FL_FLAT_BOX, 0, 0, iniStruct.MainWindowWidth, 
			iniStruct.MainWindowHeight, "" );
  
  obj = fl_add_box( FL_UP_BOX, 0, 0, iniStruct.MainWindowWidth, 30, "" );
  fl_set_object_resize( obj, FL_RESIZE_X );
  fl_set_object_gravity( obj, NorthWestGravity, EastGravity );
  
  obj = fl_add_box( FL_FLAT_BOX, 0, 30, iniStruct.MainWindowWidth, 60, "" );
  fl_set_object_resize( obj, FL_RESIZE_NONE );
  fl_set_object_gravity( obj, NorthWestGravity, NorthWestGravity );
  
  fl_setpup_default_fontstyle( FL_NORMAL_STYLE );
  fl_setpup_default_fontsize( FL_SMALL_SIZE );

  fileMenu = fl_add_menu( FL_PULLDOWN_MENU, 5, 5, 35, 20, "File" );
  fl_set_object_resize( fileMenu, FL_RESIZE_NONE );
  fl_set_object_lstyle( fileMenu, FL_BOLD_STYLE );
  fl_set_object_gravity( fileMenu, NorthWestGravity, NorthWestGravity );
  fl_set_object_shortcut( fileMenu, "Ff#F#f", 1 );
  fl_set_menu( fileMenu, 
	       "Open File...|Save File...|Write Postscript...|-------------|Exit" );
  fl_set_object_callback( fileMenu, onMenu, ( long ) this );
  fl_set_menu_item_shortcut( fileMenu, 1, "pP#P#p" );  
  fl_set_menu_item_shortcut( fileMenu, 2, "Ss#S#s" );
  fl_set_menu_item_shortcut( fileMenu, 3, "Ww#W#w" );
  fl_set_menu_item_shortcut( fileMenu, 5, "xX#X#x" );
  fl_set_menu_item_mode( fileMenu, 2, FL_PUP_GREY );
  fl_set_menu_item_mode( fileMenu, 3, FL_PUP_GREY );
  fl_set_menu_item_mode( fileMenu, 4, FL_PUP_GREY );
   
  editMenu = fl_add_menu( FL_PULLDOWN_MENU, 40, 5, 35, 20, "Edit" );
  fl_set_object_resize( editMenu, FL_RESIZE_NONE );
  fl_set_object_lstyle( editMenu, FL_BOLD_STYLE );
  fl_set_object_gravity( editMenu, NorthWestGravity, NorthWestGravity );
  fl_set_object_shortcut( editMenu, "Ee#E#e", 1 );
  fl_set_menu( editMenu, 
	       "Cut|Copy|Paste|----------|Signal Properties...|Program Properties..." );
  fl_set_menu_item_shortcut( editMenu, 6, "rR#R#r" );
  fl_set_menu_item_shortcut( editMenu, 2, "tT#T#t" );
  fl_set_menu_item_shortcut( editMenu, 3, "Cc#C#c" );
  fl_set_menu_item_shortcut( editMenu, 4, "aA#A#a" );
  fl_set_object_callback( editMenu, onMenu, ( long ) this );
  fl_set_menu_item_mode( editMenu, 1, FL_PUP_GREY );
  fl_set_menu_item_mode( editMenu, 2, FL_PUP_GREY );
  fl_set_menu_item_mode( editMenu, 3, FL_PUP_GREY );
  fl_set_menu_item_mode( editMenu, 4, FL_PUP_GREY );
  fl_set_menu_item_mode( editMenu, 5, FL_PUP_GREY );

  zoomMenu = fl_add_menu( FL_PULLDOWN_MENU, 75, 5, 45, 20, "Zoom" );
  fl_set_object_resize( zoomMenu, FL_RESIZE_NONE );
  fl_set_object_lstyle( zoomMenu, FL_BOLD_STYLE );
  fl_set_object_gravity( zoomMenu, NorthWestGravity, NorthWestGravity );
  fl_set_object_shortcut( zoomMenu, "Zz#Z#z", 1 );
  fl_set_menu( zoomMenu, "Out x2|In x2|Last|Full" );
  fl_set_object_callback( zoomMenu, onMenu, ( long ) this );
  fl_set_menu_item_mode( zoomMenu, 1, FL_PUP_GREY );
  fl_set_menu_item_mode( zoomMenu, 2, FL_PUP_GREY ); 
  fl_set_menu_item_mode( zoomMenu, 3, FL_PUP_GREY );
  fl_set_menu_item_mode( zoomMenu, 4, FL_PUP_GREY );
  fl_set_menu_item_shortcut( zoomMenu, 1, "Oo#O#o" ); 
  fl_set_menu_item_shortcut( zoomMenu, 2, "Ii#I#i" );  
  fl_set_menu_item_shortcut( zoomMenu, 3, "Ll#L#l" );  
  fl_set_menu_item_shortcut( zoomMenu, 4, "Ff#F#f" );  

  helpMenu = fl_add_menu( FL_PULLDOWN_MENU, 120, 5, 45, 20, "Help" );
  fl_set_object_shortcut( helpMenu, "Hh#H#h", 1 );
  fl_set_object_resize( helpMenu, FL_RESIZE_NONE );
  fl_set_object_gravity( helpMenu, NorthWestGravity, NorthWestGravity );
  fl_set_object_callback( helpMenu, onMenu, ( long ) this );
  fl_set_menu( helpMenu, "About" );

  openButton = fl_add_pixmapbutton( FL_NORMAL_BUTTON, 0, 30, 30, 30, "" );
  set_tip( openButton, "Open File", iniStruct.EnableTips );
  fl_set_object_resize( openButton, FL_RESIZE_NONE ); 
  fl_set_object_gravity( openButton, NorthWestGravity, NorthWestGravity );
  fl_set_pixmapbutton_data( openButton, open_xpm ); 
  fl_set_object_callback( openButton, onOpen, ( long ) this );

  saveButton = fl_add_pixmapbutton( FL_NORMAL_BUTTON, 30, 30, 30, 30, "" );
  set_tip( saveButton, "Save File", iniStruct.EnableTips );
  fl_set_object_resize( saveButton, FL_RESIZE_NONE ); 
  fl_set_object_gravity( saveButton, NorthWestGravity, NorthWestGravity );
  fl_set_pixmapbutton_data( saveButton, save_xpm ); 
  fl_set_object_callback( saveButton, onSave, ( long ) this );

  cutButton = fl_add_pixmapbutton( FL_NORMAL_BUTTON, 80, 30, 30, 30, "" );
  set_tip( cutButton, "Cut", iniStruct.EnableTips );
  fl_set_object_resize( cutButton, FL_RESIZE_NONE ); 
  fl_set_object_gravity( cutButton, NorthWestGravity, NorthWestGravity );
  fl_set_pixmapbutton_data( cutButton, cut_xpm ); 
  fl_set_object_callback( cutButton, onCut, ( long ) this );

  copyButton = fl_add_pixmapbutton( FL_NORMAL_BUTTON, 110, 30, 30, 30, "" );
  set_tip( copyButton, "Copy", iniStruct.EnableTips );
  fl_set_object_resize( copyButton, FL_RESIZE_NONE ); 
  fl_set_object_gravity( copyButton, NorthWestGravity, NorthWestGravity );
  fl_set_pixmapbutton_data( copyButton, copy_xpm ); 
  fl_set_object_callback( copyButton, onCopy, ( long ) this );

  pasteButton = fl_add_pixmapbutton( FL_NORMAL_BUTTON, 140, 30, 30, 30, "" );
  set_tip( pasteButton, "Paste", iniStruct.EnableTips );
  fl_set_object_resize( pasteButton, FL_RESIZE_NONE ); 
  fl_set_object_gravity( pasteButton, NorthWestGravity, NorthWestGravity );
  fl_set_pixmapbutton_data( pasteButton, paste_xpm ); 
  fl_set_object_callback( pasteButton, onPaste, ( long ) this );

  progPropButton = fl_add_pixmapbutton( FL_NORMAL_BUTTON, 190, 30, 30, 30, "" );
  set_tip( progPropButton, "Program Properties", iniStruct.EnableTips );
  fl_set_object_resize( progPropButton, FL_RESIZE_NONE ); 
  fl_set_object_gravity( progPropButton, NorthWestGravity, NorthWestGravity );
  fl_set_pixmapbutton_data( progPropButton, ptools_xpm ); 
  fl_set_object_callback( progPropButton, onProgProperties, ( long ) this );

  propButton = fl_add_pixmapbutton( FL_NORMAL_BUTTON, 220, 30, 30, 30, "" );
  set_tip( propButton, "Signal Properties", iniStruct.EnableTips );
  fl_set_object_resize( propButton, FL_RESIZE_NONE ); 
  fl_set_object_gravity( propButton, NorthWestGravity, NorthWestGravity );
  fl_set_pixmapbutton_data( propButton, tools_xpm ); 
  fl_set_object_callback( propButton, onProperties, ( long ) this );

  canvas = fl_add_canvas( FL_SCROLLED_CANVAS, 0, 60, 
			  iniStruct.MainWindowWidth - 15, 
			  iniStruct.MainWindowHeight - 75, "" );
  fl_set_object_gravity( canvas, NorthWestGravity, SouthEastGravity );
  fl_set_object_resize( canvas, FL_RESIZE_ALL ); 
  fl_set_object_boxtype( canvas, FL_FLAT_BOX );
  fl_set_object_bw( canvas, 0 );
  fl_set_object_callback( canvas, onPaint, ( long ) this );
  fl_add_canvas_handler( canvas, Expose, onPaint, this );
  fl_add_canvas_handler( canvas, ButtonPress, onButtonPress, this );
  fl_add_canvas_handler( canvas, ButtonRelease, onButtonRelease, this );
  fl_add_canvas_handler( canvas, MotionNotify, onMouseMove, this );

  hScrollBar = fl_add_scrollbar( FL_HOR_SCROLLBAR, 0, iniStruct.MainWindowHeight - 15, 
				 iniStruct.MainWindowWidth, 15, "" );
  fl_set_object_resize( hScrollBar, FL_RESIZE_X ); 
  fl_set_object_gravity( hScrollBar, FL_SouthWest, FL_NoGravity );
  fl_set_scrollbar_return( hScrollBar, FL_RETURN_CHANGED );
  fl_set_object_callback( hScrollBar, onHScroll, ( long ) this );
  fl_set_scrollbar_value( hScrollBar, 0.0 );

  vScrollBar = fl_add_scrollbar( FL_VERT_SCROLLBAR, iniStruct.MainWindowWidth - 15, 
				 60, 15, iniStruct.MainWindowHeight - 75, "" );
  fl_set_object_resize( vScrollBar, FL_RESIZE_Y ); 
  fl_set_object_gravity( vScrollBar, FL_NorthEast, FL_South );
  fl_set_scrollbar_return( vScrollBar, FL_RETURN_CHANGED );
  fl_set_object_callback( vScrollBar, onVScroll, ( long ) this );
  fl_set_scrollbar_value( vScrollBar, 0.0 );

  fl_set_form_minsize( mainWindow, 250, 150 );
  fl_end_form();   
  allocateColors();
}

void 
App::allocateColors()
{
  Display *disp = fl_get_display();

  Colormap colormap = DefaultColormap( disp, DefaultScreen( disp ) );
  colors[ BACKGROUND ].flags = DoRed | DoGreen | DoBlue;
  colors[ BACKGROUND ].green = iniStruct.BackgroundColorG;
  colors[ BACKGROUND ].blue = iniStruct.BackgroundColorB;
  colors[ BACKGROUND ].red = iniStruct.BackgroundColorR;
  XAllocColor( disp, colormap, &colors[ BACKGROUND ] );

  colors[ FONT ].flags = DoRed | DoGreen | DoBlue;
  colors[ FONT ].green = iniStruct.FontColorG;
  colors[ FONT ].blue = iniStruct.FontColorB;
  colors[ FONT ].red = iniStruct.FontColorR;
  XAllocColor( disp, colormap, &colors[ FONT ] );

  colors[ SIGNAL ].flags = DoRed | DoGreen | DoBlue;
  colors[ SIGNAL ].green = iniStruct.SignalColorG;
  colors[ SIGNAL ].blue = iniStruct.SignalColorB;
  colors[ SIGNAL ].red = iniStruct.SignalColorR;
  XAllocColor( disp, colormap, &colors[ SIGNAL ] );

  colors[ BUS ].flags = DoRed | DoGreen | DoBlue;
  colors[ BUS ].green = iniStruct.BusColorG;
  colors[ BUS ].blue = iniStruct.BusColorB;
  colors[ BUS ].red = iniStruct.BusColorR;
  XAllocColor( disp, colormap, &colors[ BUS ] );

  colors[ CURSOR ].flags = DoRed | DoGreen | DoBlue;
  colors[ CURSOR ].green = iniStruct.CursorColorG;
  colors[ CURSOR ].blue = iniStruct.CursorColorB;
  colors[ CURSOR ].red = iniStruct.CursorColorR;
  XAllocColor( disp, colormap, &colors[ CURSOR ] );

  colors[ 5 ].flags = DoRed | DoGreen | DoBlue;
  colors[ 5 ].green = 0xFFFF;
  colors[ 5 ].blue = 0x0;
  colors[ 5 ].red = 0xFFFF;
  XAllocColor( disp, colormap, &colors[ 5 ] );
  colors[ 6 ].flags = DoRed | DoGreen | DoBlue;
  colors[ 6 ].green = 0xFFFF;
  colors[ 6 ].blue = 0xFFFF;
  colors[ 6 ].red = 0x0;
  XAllocColor( disp, colormap, &colors[ 6 ] );
  colors[ 7 ].flags = DoRed | DoGreen | DoBlue;
  colors[ 7 ].green = 0xa1a1;
  colors[ 7 ].blue = 0xa1a1;
  colors[ 7 ].red = 0xa1a1;
  XAllocColor( disp, colormap, &colors[ 7 ] );
}

///////////////////////////////////////////////////////////////////////
void
App::resetScrollBars()
{
  if ( canvas->w - sigNameWidth > numSamples * spanLength )
  {
    startSample = 0;
    fl_deactivate_object( hScrollBar );
    fl_set_scrollbar_size( hScrollBar, 1.0 );    
  }
  else
  {
    int tempStartSample = numSamples - ( canvas->w - sigNameWidth ) / spanLength;
    if ( tempStartSample < startSample )
      startSample = tempStartSample;
    fl_activate_object( hScrollBar );
    fl_set_scrollbar_size( hScrollBar, 0.15 );    
    int maxVal = numSamples - ( ( canvas->w - sigNameWidth ) / spanLength );
    fl_set_scrollbar_bounds( hScrollBar, 0.0, ( double ) maxVal );
    fl_set_scrollbar_step( hScrollBar, 1.0 );
    fl_set_scrollbar_increment( hScrollBar, 1.0, 1.0 );
  }
  // Calculate vertical scrolling range
  if ( canvas->h > numSignals * SIG_NAME_HEIGHT )
  {
    startSignal = 0;
    fl_deactivate_object( vScrollBar );
    fl_set_scrollbar_value( vScrollBar, 0.0 );
    fl_set_scrollbar_size( vScrollBar, 1.0 ); 
  }
  else
  {
    int tempStartSignal = numSignals - canvas->h / SIG_NAME_HEIGHT;
    if ( tempStartSignal < startSignal )
      startSignal = tempStartSignal;
    fl_activate_object( vScrollBar );
    fl_set_scrollbar_size( vScrollBar, 0.15 );    
    int maxVal = numSignals - ( canvas->h / SIG_NAME_HEIGHT );
    fl_set_scrollbar_bounds( vScrollBar, 0.0, ( double ) maxVal );
    fl_set_scrollbar_step( vScrollBar, 1.0 );
    fl_set_scrollbar_increment( vScrollBar, 1.0, 1.0 );
  }
}

void 
App::onHScroll( FL_OBJECT *ob, long userData )
{
  App *app = ( App * ) userData;
  double val = fl_get_scrollbar_value( ob );
  app->startSample = ( int ) val;
  app->selectedSample = ( app->cursorPos1 - app->sigNameWidth ) / 
                   app->spanLength + app->startSample;
  app->update();
}

void 
App::onVScroll( FL_OBJECT *ob, long userData )
{
  App *app = ( App * ) userData;
  double val = fl_get_scrollbar_value( ob );
  app->startSignal = ( int ) val;
  app->update();
}

//////////////////////////////////////////////////////////////////////
void
App::makeDblBuff()
{
  dBuffer = XCreatePixmap( fl_get_display(), FL_ObjWin( canvas ), canvas->w, 
			   canvas->h, fl_get_canvas_depth( canvas ) );
  orgPixmapWidth = canvas->w;
  orgPixmapHeight = canvas->h;
}

//////////////////////////////////////////////////////////////////////
App::~App()
{ 
  fl_free_form( mainWindow );
  XFreePixmap( fl_get_display(), dBuffer );
  XFreePixmap( fl_get_display(), busPix );
  XFreePixmap( fl_get_display(), bus2Pix );
  XFreePixmap( fl_get_display(), sigPix );
  if ( numSignals > 0 )
  {
    for ( int i = 0; i < numSignals; i++ )
      delete sig[ i ];
  }
  if ( tempCutSig )
    delete tempCutSig;
  if ( tempCopySig )
    delete tempCopySig;
}
 
void
App::deleteContents()
{
  if ( numSignals > 0 )
  {
    for ( int i = 0; i < numSignals; i++ )
      delete sig[ i ];
  }
  numSignals = 0;
}

///////////////////////////////////////////////////////////////////////////
void 
App::show( const string &title )
{
  string newTitle;
  int open = 0;

  if ( startFile != "" )
  {
    newTitle = "WaView - ";

    if ( onOpened( startFile ) )
    {
      newTitle += startFile;
    }
    else
    {
      newTitle += "untitled";
    }      
  }
  else
    newTitle = title;

  fl_show_form( mainWindow, FL_FREE_SIZE, FL_FULLBORDER, 
		newTitle.getBuffer() ); 
  fl_set_form_position( mainWindow, iniStruct.MainWindowXPosition, 
			iniStruct.MainWindowYPosition );
  makeDblBuff();
  update();
}

///////////////////////////////////////////////////////////////////////////
void 
App::parseIniFile( int iniLocation )
{
  string iniPath;

  if ( iniLocation == HOME )
  {
    string homePath = getenv( "WAVIEW_HOME" );
    if ( ( string ) homePath == "" )
      return;
    iniPath = homePath;
    iniPath += "/waview.ini";
  }
  else if ( iniLocation == LOCAL )
  {
    iniPath = "./waview.ini";
  }

  FILE *iniPtr = fopen( iniPath.getBuffer(), "r" );
  if ( !iniPtr )
    return;
  
  cout << "Opening file " << iniPath << endl;  
  char line[ 200 ];
  while ( fgets( line, 200, iniPtr ) )
  {
    string line2 = line;
    string tok = strtok( line, "= \n\t" );
    if ( tok.len() == 0 || tok[ 0 ] == '#' )
      continue;

    if ( tok == "MainWindowXPosition" )
    {
      tok = strtok( NULL, "= \n\t" );
      if ( tok == "=" )
	tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%d", &iniStruct.MainWindowXPosition );
      if ( iniStruct.MainWindowXPosition <= 0 )
      {
	cerr << "Error while parsing file " << iniPath;
	cerr << ": Illegal value for parameter MainWindowXPosition." << endl;
	iniStruct.MainWindowXPosition = 5;
      }
    }
    else if (  tok == "MainWindowYPosition" )
    {
      tok = strtok( NULL, "= \n\t" );
      if (  tok == "=" )
	tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%d", &iniStruct.MainWindowYPosition );
      if ( iniStruct.MainWindowYPosition <= 0 )
      {
	cerr << "Error while parsing file " << iniPath;
	cerr << ": Illegal value for parameter MainWindowYPosition." << endl;
	iniStruct.MainWindowYPosition = 25;
      }
    }
    else if (  tok == "MainWindowWidth" )
    {
      tok = strtok( NULL, "= \n\t" );
      if (  tok == "=" )
	tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%d", &iniStruct.MainWindowWidth );
      if ( iniStruct.MainWindowWidth <= 50 )
      {
	cerr << "Error while parsing file " << iniPath;
	cerr << ": Illegal value for parameter MainWindowWidth." << endl;
	iniStruct.MainWindowWidth = 400;
      }
    }
    else if (  tok == "MainWindowHeight" )
    {
      tok = strtok( NULL, "= \n\t" );
      if (  tok == "=" )
	tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%d", &iniStruct.MainWindowHeight );
      if ( iniStruct.MainWindowHeight <= 50 )
      {
	cerr << "Error while parsing file " << iniPath;
	cerr << ": Illegal value for parameter MainWindowHeight." << endl;
	iniStruct.MainWindowHeight = 230;
      }
    }
    else if (  tok == "DefaultRadix" )
    {
      tok = strtok( NULL, "= \n\t" );
      if (  tok == "=" )
	tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%d", &iniStruct.DefaultRadix );
      if ( iniStruct.DefaultRadix != 0 && iniStruct.DefaultRadix != 2 &&
	   iniStruct.DefaultRadix != 8 && iniStruct.DefaultRadix != 10 &&
	   iniStruct.DefaultRadix != 16 )
      {
	cerr << "Error while parsing file " << iniPath;
	cerr << ": Illegal value for parameter DefaultRadix." << endl;
	iniStruct.DefaultRadix = 0;
      }
    }
    else if (  tok == "DisplayHierarchy" )
    {
      tok = strtok( NULL, "= \n\t" );
      if (  tok == "=" )
	tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%d", &iniStruct.DisplayHierarchy );
      if ( iniStruct.DisplayHierarchy != 0 && iniStruct.DisplayHierarchy != 1 )
      {
	cerr << "Error while parsing file " << iniPath;
	cerr << ": Illegal value for parameter DisplayHierarchy " << 
	  iniStruct.DisplayHierarchy << "." << endl;
	iniStruct.DisplayHierarchy = 1;
      }
    }
    else if (  tok == "SignalNameWidth" )
    {
      tok = strtok( NULL, "= \n\t" );
      if (  tok == "=" )
	tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%d", &iniStruct.SignalNameWidth );
      if ( iniStruct.SignalNameWidth < 0 || 
	   iniStruct.SignalNameWidth > iniStruct.MainWindowWidth )
      {
	cerr << "Error while parsing file " << iniPath;
	cerr << ": Illegal value for parameter SignalNameWidth " << 
	  iniStruct.SignalNameWidth << "." << endl;
	iniStruct.SignalNameWidth = 150;
      }
    }
    else if (  tok == "EnableTips" )
    {
      tok = strtok( NULL, "= \n\t" );
      if (  tok == "=" )
	tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%d", &iniStruct.EnableTips );
      if ( iniStruct.EnableTips != 0 && iniStruct.EnableTips != 1 )
      {
	cerr << "Error while parsing file " << iniPath;
	cerr << ": Illegal value for parameter EnableTips " << 
	  iniStruct.EnableTips << "." << endl;
	iniStruct.EnableTips = 1;
      }
    }
    else if (  tok == "BackgroundColor" )
    {
      tok = strtok( NULL, "= \n\t" );
      if (  tok == "=" )
	tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.BackgroundColorR );
      tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.BackgroundColorG );
      tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.BackgroundColorB );
    }
    else if (  tok == "FontColor" )
    {
      tok = strtok( NULL, "= \n\t" );
      if (  tok == "=" )
	tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.FontColorR );
      tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.FontColorG );
      tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.FontColorB );
    }
    else if (  tok == "SignalColor" )
    {
      tok = strtok( NULL, "= \n\t" );
      if (  tok == "=" )
	tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.SignalColorR );
      tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.SignalColorG );
      tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.SignalColorB );
    }
    else if (  tok == "BusColor" )
    {
      tok = strtok( NULL, "= \n\t" );
      if (  tok == "=" )
	tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.BusColorR );
      tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.BusColorG );
      tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.BusColorB );
    }
    else if (  tok == "CursorColor" )
    {
      tok = strtok( NULL, "= \n\t" );
      if (  tok == "=" )
	tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.CursorColorR );
      tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.CursorColorG );
      tok = strtok( NULL, " \n\t" );
      sscanf( tok.getBuffer(), "%x", &iniStruct.CursorColorB );
    }
    else
    {
      cerr << "Error while parsing file " << iniPath;
      cerr << ": Illegal parameter " << tok << "." << endl;
    }
  }
}

////////////////////////////////////////////////////////////////////////////////
void 
App::onMouseMove( XEvent *e )
{
  // Move cursor
  if ( button1 && numSignals > 0 && e->xmotion.x >= sigNameWidth &&
       e->xmotion.x < canvas->w && !moveDivider )
  {
    int mod = ( e->xmotion.x - sigNameWidth ) % spanLength;
    if ( mod )
    {
      if ( mod > ( spanLength >> 1 ) )
	cursorPos1 = e->xmotion.x - mod + spanLength;
      else
	cursorPos1 = e->xmotion.x - mod;
    }
    else
      cursorPos1 = e->xmotion.x;

    selectedSample = ( cursorPos1 - sigNameWidth ) / spanLength + startSample;
    // Find selected signal based on mouse click
    selectedSignal = ( ( e->xbutton.y - 4 ) / SIG_NAME_HEIGHT ) + startSignal;
    if ( selectedSignal >= numSignals )
      selectedSignal = - 1;
    fl_set_menu_item_mode( editMenu, 1, FL_PUP_NONE );
    fl_set_menu_item_mode( editMenu, 2, FL_PUP_NONE );
    fl_set_menu_item_mode( editMenu, 3, FL_PUP_GRAY );
    fl_set_menu_item_mode( editMenu, 5, FL_PUP_NONE );
    // Update properties dialog only if it is visible
    propForm->setSelected( selectedSignal );
    update();
  }
  else if ( button1 && numSignals > 0 && 
	    e->xmotion.x < ( sigNameWidth - 10 ) && !moveDivider )
  {
    // Find selected signal based on mouse click
    selectedSignal = ( ( e->xmotion.y - 4 ) / SIG_NAME_HEIGHT ) + startSignal;
    if ( selectedSignal >= numSignals )
      selectedSignal = - 1;
    fl_set_menu_item_mode( editMenu, 1, FL_PUP_NONE );
    fl_set_menu_item_mode( editMenu, 2, FL_PUP_NONE );
    fl_set_menu_item_mode( editMenu, 3, FL_PUP_GRAY );
    fl_set_menu_item_mode( editMenu, 5, FL_PUP_NONE );
    // Update properties dialog only if it is visible
    propForm->setSelected( selectedSignal );
    update();    
  }
  else if ( moveDivider )
  {
    sigNameWidth = e->xmotion.x;
    if ( sigNameWidth > canvas->w )
      sigNameWidth = canvas->w;
    if ( sigNameWidth < 10 )
      sigNameWidth = 10;
    resetScrollBars();
    update();    
  }
  // Stuf to move zoom box
  else if ( zoomBoxOn && e->xmotion.x >= sigNameWidth )
  {
    zoomBoxX = e->xmotion.x;
    zoomBoxY = e->xmotion.y;
    update();
  }    
}

////////////////////////////////////////////////////////////////////////////////
void 
App::onButtonPress( XEvent *e )
{
  if ( e->xbutton.button == Button1 && 
	    e->xmotion.x >= sigNameWidth )
  {
    button1 = 1;
    moveDivider = 0;    
  }
  // Stuff to move divider
  else if ( e->xbutton.button == Button1 && e->xbutton.x >= sigNameWidth - 10 &&
	    e->xbutton.x < sigNameWidth )
  {
    button1 = 1;
    moveDivider = 1;    
  }
  else if ( e->xbutton.button == Button1 && e->xbutton.x < sigNameWidth - 10 )
  {
    button1 = 1;
    moveDivider = 0;    
  }
  // Stuff to move zoom box 
  else if ( e->xbutton.button == Button2 && 
	    e->xbutton.x >= sigNameWidth )
  {
    button2 = 1;
    zoomBoxOn = 1;
    zoomBoxOrgX = e->xbutton.x;
    zoomBoxOrgY = e->xbutton.y;
  }
}

////////////////////////////////////////////////////////////////////////////////
void 
App::onButtonRelease( XEvent *e )
{
  if ( e->xbutton.button == Button1 && e->xbutton.x >= sigNameWidth )
  {
    int mod = ( e->xbutton.x - sigNameWidth ) % spanLength;
    if ( mod )
    {
      if ( mod > ( spanLength >> 1 ) )
	cursorPos1 = e->xbutton.x - mod + spanLength;
      else
	cursorPos1 = e->xbutton.x - mod;
    }
    else
      cursorPos1 = e->xbutton.x;

    selectedSample = ( cursorPos1 - sigNameWidth ) / 
                          spanLength + startSample;
    moveDivider = 0; 
    button1 = 0;
    selectedSignal = ( ( e->xbutton.y - 4 ) / SIG_NAME_HEIGHT ) + 
                          startSignal;
    if ( selectedSignal >= numSignals )
      selectedSignal = - 1;
    fl_set_menu_item_mode( editMenu, 1, FL_PUP_NONE );
    fl_set_menu_item_mode( editMenu, 2, FL_PUP_NONE );
    fl_set_menu_item_mode( editMenu, 3, FL_PUP_GRAY );
    fl_set_menu_item_mode( editMenu, 5, FL_PUP_NONE );
    // Update properties dialog only if it is visible
    propForm->setSelected( selectedSignal );
    update();
  }
  else if ( e->xbutton.button == Button1 && numSignals > 0 && 
	    e->xbutton.x < ( sigNameWidth - 10 ) && !moveDivider )
  {
    selectedSignal = ( ( e->xbutton.y - 4 ) / SIG_NAME_HEIGHT ) + 
                          startSignal;
    if ( selectedSignal >= numSignals )
      selectedSignal = - 1;
    fl_set_menu_item_mode( editMenu, 1, FL_PUP_NONE );
    fl_set_menu_item_mode( editMenu, 2, FL_PUP_NONE );
    fl_set_menu_item_mode( editMenu, 3, FL_PUP_GRAY );
    fl_set_menu_item_mode( editMenu, 5, FL_PUP_NONE );
    // Update properties dialog only if it is visible
    propForm->setSelected( selectedSignal );
    update();
  }
  // Figure out new zoom based on zoom box
  else if ( e->xbutton.button == Button2 && 
	    e->xbutton.x >= sigNameWidth && zoomBoxOn )
  {
    button2 = 0;
    zoomBoxOn = 0;
    if ( numSignals > 0 )
    {
      if ( zoomBoxOrgX >= zoomBoxX )
	return;
      else if ( zoomBoxOrgX >= zoomBoxX )
      {
	int temp = zoomBoxOrgX;
	zoomBoxOrgX = zoomBoxX;
	zoomBoxX = temp;
      }

      int zoomStartSample = ( zoomBoxOrgX - sigNameWidth ) 
                            / spanLength + startSample;
      int zoomEndSample = ( zoomBoxX - sigNameWidth ) / 
                          spanLength + startSample;
      lastSpanLength = spanLength;
      lastStartSample = startSample;
      if ( zoomStartSample == zoomEndSample )
	spanLength = canvas->w - sigNameWidth;
      else
	spanLength = ( canvas->w - sigNameWidth ) / 
	                  ( zoomEndSample - zoomStartSample );
      if ( spanLength <= 0 )
	spanLength = 1;
      if ( spanLength > canvas->w - sigNameWidth )
	spanLength = canvas->w - sigNameWidth;
      startSample = zoomStartSample;

      // Figure out cursor position
      int mod = ( cursorPos1 - sigNameWidth ) % spanLength;
      if ( mod )
      {
	if ( mod > ( spanLength >> 1 ) )
	  cursorPos1 = cursorPos1 - mod + spanLength;
	else
	  cursorPos1 = cursorPos1 - mod;
      }
      resetScrollBars();
      update();
    }
  }  

  if ( e->xbutton.button == Button1 )
  {
    button1 = 0;
    moveDivider = 0; 
  }  
}

///////////////////////////////////////////////////////////////////////
void 
App::onPaint()
{
  GC gc = fl_state[ fl_get_vclass() ].gc[ 1 ];
  Display *disp = fl_get_display();
  Window w = FL_ObjWin( canvas );

  if ( canvas->w != orgPixmapWidth || 
       canvas->h != orgPixmapHeight )
  {
    resetScrollBars();
    XFreePixmap( fl_get_display(), dBuffer );
    makeDblBuff();
  }

  if ( selectedSample >= numSamples )
  {
    selectedSample = numSamples - 1;
    if ( selectedSample < 0 )
      selectedSample = 0;
  }

  // Erase Background
  XSetForeground( disp, gc, colors[ BACKGROUND ].pixel );
  XFillRectangle( disp, dBuffer, gc, 0, 0, sigNameWidth - 1, canvas->h );

  // Loop to print signal names
  int y = SIG_NAME_HEIGHT;
  for ( int j = startSignal; j < numSignals; j++ )
  {
    Bus *sigA = sig[ j ];

    XSetForeground( disp, gc, colors[ FONT ].pixel );
    string name = sigA->getName( iniStruct.DisplayHierarchy );
    name += " = ";
    name += sigA->toStr( selectedSample );
    XDrawString( disp, dBuffer, gc, 20, y, name.getBuffer(), name.len() );
    if ( sigA->getWidth() > 1 )
      XCopyArea( disp, busPix, dBuffer, gc, 0, 0, 9, 9, 5, y - 8 );
    else
      XCopyArea( disp, sigPix, dBuffer, gc, 0, 0, 9, 9, 5, y - 8 );

    if ( j == selectedSignal )
    {
      XDrawRectangle( disp, dBuffer, gc, 15, y - 12, name.len() * 6 + 7, 15 );
    }      
    y += SIG_NAME_HEIGHT;
  }

  XSetForeground( disp, gc, colors[ BACKGROUND ].pixel );
  XFillRectangle( disp, dBuffer, gc, sigNameWidth, 0, canvas->w, canvas->h );

  // Draw zoom box
  if ( numSignals > 0 && zoomBoxOn )
  {
    XSetForeground( disp, gc, colors[ FONT ].pixel );
    XDrawLine( disp, dBuffer, gc, zoomBoxOrgX, zoomBoxOrgY, 
	       zoomBoxX, zoomBoxOrgY );
    XDrawLine( disp, dBuffer, gc, zoomBoxX, 
	       zoomBoxOrgY, zoomBoxX, zoomBoxY );
    XDrawLine( disp, dBuffer, gc, zoomBoxX, zoomBoxY,
	       zoomBoxOrgX, zoomBoxY );
    XDrawLine( disp, dBuffer, gc, zoomBoxOrgX, zoomBoxY, 
	       zoomBoxOrgX, zoomBoxOrgY );
  }

  y = SIG_NAME_HEIGHT;
  int samplesShown;
  if ( numSignals )
  {
    samplesShown = ( ( canvas->w - sigNameWidth ) / spanLength ) + 1;
    if ( samplesShown > ( numSamples - startSample ) )
      samplesShown = numSamples - startSample;
  }
  for ( int j = startSignal; j < numSignals; j++ )
  {
    Bus *sigA = sig[ j ];

    if ( sigA->getWidth() == 1 )
    {
      int x = sigNameWidth;      // Starting x position of signals on window
      for ( int i = startSample; i < startSample + samplesShown; i++ )
      {
	if ( strcmp( sigA->get( i ), "0" ) == 0 )
        {
	  XSetForeground( disp, gc, colors[ SIGNAL ].pixel );
	  XDrawLine( disp, dBuffer, gc, x, y, x + spanLength, y );
	  if ( i > 0 )
          { 
	    if ( strcmp( sigA->get( i - 1 ), "1" ) == 0 )
	    {
	      XDrawLine( disp, dBuffer, gc, x, y, x, y - 14 );
	    }
	  }	  
	}
	else if ( strcmp( sigA->get( i ), "1" ) == 0 )
        {
	  XSetForeground( disp, gc, colors[ SIGNAL ].pixel );
	  XDrawLine( disp, dBuffer, gc, x, y - 14, x + spanLength, y - 14 );
	  if ( i > 0 )
          {
	    if ( strcmp( sigA->get( i - 1 ), "0" ) == 0 )
	    {
	      XDrawLine( disp, dBuffer, gc, x, y, x, y - 14 );
	    }
	  }	  
	}
	else if ( strcmp( sigA->get( i ), "Z" ) == 0 )
	{
	  XSetForeground( disp, gc, colors[ 2 ].pixel );
	  XDrawLine( disp, dBuffer, gc, x, y - 7, x + spanLength, y - 7 );
	}
	else if ( strcmp( sigA->get( i ), "X" ) == 0 )
	{
	  XSetForeground( disp, gc, colors[ 3 ].pixel );
	  XDrawLine( disp, dBuffer, gc, x, y - 7, x + spanLength, y - 7 );
	}
	x += spanLength;
      }
    }
    // Width > 1
    else
    {
      int x = sigNameWidth; 
      for ( int i = startSample; i < startSample + samplesShown; i++ )
      {
	string val = sigA->toStr( i );
	if ( i == startSample )
        {
	  XSetForeground( disp, gc, colors[ BUS ].pixel );
	  XDrawLine( disp, dBuffer, gc, x, y, x + spanLength - 1, y );
	  XDrawLine( disp, dBuffer, gc, x, y - 14, x + spanLength - 1, 
		     y - 14);
	  // Calculate length of unchanged section of the bus
	  int length = spanLength;
	  for ( int count = i; count < sigA->getNum() - 1; count++ )
	  {
	    string v1 = sigA->toStr( count );
	    string v2 = sigA->toStr( count + 1 );
	    if ( v1 == v2 )
	      length += spanLength;
	    else
	      break;
	  }
	  // Do I display the bus value ?
	  if ( ( length - 2 ) > val.len() * 6 )
	  {
	    XSetForeground( disp, gc, colors[ FONT ].pixel );
	    XDrawString( disp, dBuffer, gc, x + 1, y - 2, val.getBuffer(), val.len() );
	  }
	}
	else if ( i > 0 )
        {
	  if ( strcmp( sigA->get( i ), sigA->get( i - 1 ) ) == 0 )
	  {
	    XSetForeground( disp, gc, colors[ BUS ].pixel );
	    XDrawLine( disp, dBuffer, gc, x - 1, y, x + spanLength - 1, y );
	    XDrawLine( disp, dBuffer, gc, x - 1, y - 14, x + spanLength - 1, 
		       y - 14);
	  }
	  else
	  {
	    XSetForeground( disp, gc, colors[ BUS ].pixel );
	    XDrawLine( disp, dBuffer, gc, x + 1, y, x + spanLength - 1, y );
	    XDrawLine( disp, dBuffer, gc, x + 1, y - 14, x + spanLength - 1, 
		       y - 14);
	  
	    XDrawLine( disp, dBuffer, gc, x - 1, y, x + 1, y - 14 );
	    XDrawLine( disp, dBuffer, gc, x - 1, y - 14, x + 1, y );

	    // Calculate length of unchanged section of the bus
	    int length = spanLength;
	    for ( int count = i; count < sigA->getNum() - 1; count++ )
	    {
	      string v1 = sigA->toStr( count );
	      string v2 = sigA->toStr( count + 1 );
	      if ( v1 == v2 )
		length += spanLength;
	      else
		break;
	    }
	    // Do I display the bus value ?
	    if ( ( length - 2 ) > val.len() * 6 )
	    {
	      XSetForeground( disp, gc, colors[ FONT ].pixel );
	      XDrawString( disp, dBuffer, gc, x + 3, y - 2, val.getBuffer(), val.len() );
	    }
	  }
	}
	x += spanLength;
      }
    } 
    y += SIG_NAME_HEIGHT;
  }
  // Draw divider between signal names and samples
  XSetForeground( disp, gc, colors[ 7 ].pixel );
  for ( register int i = sigNameWidth - 10; i < sigNameWidth; i++ )
    XDrawLine( disp, dBuffer, gc, i, 0, i, canvas->h );

  // Draw cursor on top of everything
  if ( cursorPos1 > 0 && numSignals > 0 )
  {
    XSetForeground( disp, gc, colors[ CURSOR ].pixel );
    XDrawLine( disp, dBuffer, gc, cursorPos1, 0, cursorPos1, canvas->h );
  }

  // Blast double buffer to screen
  XCopyArea( disp, dBuffer, w, gc, 0, 0, canvas->w, canvas->h, 0, 0 );
}

////////////////////////////////////////////////////////////////////////////////
void 
App::onPrint()
{
  string fileName;
  fileName = fl_show_fselector( "Write Postscript file", "./", "*.ps", "" );
  if ( !fileName )
    return;

  fl_set_cursor( mainWindow->window, XC_watch );
  XFlush( fl_get_display() );

  FILE *outFile = fopen( fileName.getBuffer(), "w" );
  if ( !outFile )
  {
    string message = "WaView: Cannot write postscript file ";
    message += fileName;
    fl_show_alert( message.getBuffer(), NULL, NULL, 1 );
    return;
  }

  string homePath;
  string home = getenv( "WAVIEW_HOME" );
  if ( home == "" )
    homePath = "./init.pp";
  else
  {
    homePath = home;
    homePath += "/init.pp";
  }
  FILE *inFile = fopen( homePath.getBuffer(), "r" );
  if ( !inFile )
  {
    char message[ 150 ];
    sprintf( message, "WaView: Cannot open file file \"init.pp\"." );
    fl_show_alert( message, NULL, NULL, 1 );
    return;
  }

  // Copy stuff in init file to output file
  char line[ 200 ];
  while ( fgets( line, 200, inFile ) )
  {
    fprintf( outFile, "%s", line );
  }
  fprintf( outFile, "\n\n" );

  int y = 70;
  int samplesShown;
  if ( numSignals )
  {
    samplesShown = ( ( canvas->w - sigNameWidth ) / spanLength ) + 1;
    if ( samplesShown > ( numSamples - startSample ) )
      samplesShown = numSamples - startSample;
  }
  for ( int j = startSignal; j < numSignals; j++ )
  {
    if ( j == 35 )
      break;

    Bus *sigA = sig[ j ];

    if ( sigA->getWidth() == 1 )
    {
      fprintf( outFile, "\nnew_sig\ngsave\n90 rotate\n" );
      fprintf( outFile, "%s (%s) sig_name\n", sigA->get( startSample ), 
	       ( sigA->getName() ).getBuffer() );

      int totalLength = 0;
      for ( int i = startSample + 1; i < startSample + samplesShown; i++ )
      {
	totalLength += spanLength;
	if ( totalLength >= 600 ) 
	  break;

	if ( strcmp( sigA->get( i ), "0" ) == 0 )
        {
	  fprintf( outFile, "%d line\n", spanLength );
	  if ( i > 0 )
          { 
	    if ( strcmp( sigA->get( i - 1 ), "1" ) == 0 )
	    {
	      fprintf( outFile, "neg_edge\n" );
	    }
	  }	  
	}
	else if ( strcmp( sigA->get( i ), "1" ) == 0 )
        {
	  fprintf( outFile, "%d line\n", spanLength );
	  if ( i > 0 )
          {
	    if ( strcmp( sigA->get( i - 1 ), "0" ) == 0 )
	    {
	      fprintf( outFile, "pos_edge\n" );
	    }
	  }	  
	}
      }
    }
    // Width > 1
    else
    {
      int currLength = spanLength;
      int special = 1;
      fprintf( outFile, "\nnew_sig\ngsave\n90 rotate\n" );
      fprintf( outFile, "(%s) bus_name\n", sigA->getName().getBuffer() );
      int totalLength = 0;
      for ( int i = startSample + 1; i < startSample + samplesShown; i++ )
      {
	totalLength += spanLength;
	if ( totalLength >= 600 ) 
	  break;

	string val = sigA->toStr( i );
	if ( i > 0 && strcmp( sigA->get( i ), sigA->get( i - 1 ) ) == 0 ||
	     i == 0 )
	{
	  currLength += spanLength;
	}
	else
	{
	  if ( i == startSample + samplesShown - 1 )
	    special = 0;

	  fprintf( outFile, "%d (%s) bus_line\nbus_change\n", currLength - 2, 
		   sigA->toStr( i - 1 ) );
	  currLength = spanLength;
	}	
      }
      if ( special )      
	fprintf( outFile, "%d (%s) bus_line\nbus_change\n", currLength - 2, 
		 sigA->toStr( startSample + samplesShown - 2 ) );
    } 

    y += 20;
    fprintf( outFile, "stroke\ngrestore\n" );
  }
  fprintf( outFile, "\nshowpage\n" );
  fclose( inFile );
  fclose( outFile );
  
  fl_set_cursor( mainWindow->window, XC_top_left_arrow );
  XFlush( fl_get_display() );
}


/////////////////////////////////////////////////////////////////////
void 
App::onSave( FL_OBJECT *ob, long userData )
{
  App *app = ( App * ) userData;

  if ( app->numSignals == 0 )
    return;

  string fileName = fl_show_fselector( "Save file", "./", "*.pat", "" );
  if ( !fileName )
    return;

  FILE *outFile = fopen( fileName.getBuffer(), "w" );
  if ( !outFile )
  {
    string message = "WaView: Cannot write file ";
    message += fileName;
    fl_show_alert( message.getBuffer(), NULL, NULL, 1 );
    return;
  }

  fprintf( outFile, "\n" );
  for ( int j = 0; j < app->numSignals; j++ )
  {
    Bus *sigA = ( Bus * ) app->sig[ j ];
    
    if ( sigA->getWidth() == 1 )
      fprintf( outFile, "in\t%s B;;\n", sigA->getName().getBuffer() );
    else
    {
      switch ( sigA->getType() )
      {
      case BIN :
	fprintf( outFile, "in\t%s (%d downto 0) B;;\n", sigA->getName().getBuffer(),
		 sigA->getWidth() - 1 );
	break;
      case DEC :
	fprintf( outFile, "in\t%s (%d downto 0) D;;\n", sigA->getName().getBuffer(),
		 sigA->getWidth() - 1 );
	break;
      case OCT :
	fprintf( outFile, "in\t%s (%d downto 0) O;;\n", sigA->getName().getBuffer(),
		 sigA->getWidth() - 1 );
	break;
      case HEX :
	fprintf( outFile, "in\t%s (%d downto 0) X;;\n", 
		 sigA->getName().getBuffer(),
		 sigA->getWidth() - 1 );
	break;
      default :
	break;
      }
    }
  }
  fprintf( outFile, "\nbegin\n" );
  for ( int j = 0; j < app->numSamples; j++ )
  {
    fprintf( outFile, "         : " );
    for ( int i = 0; i < app->numSignals; i++ )
    {
      Bus *sigA = ( Bus * ) app->sig[ i ];
      string val = sigA->toStr( j );
      for ( int c = 0; c < val.len(); c++ )
	val[ c ] = tolower( val[ c ] );
      fprintf( outFile, "%s ", val.getBuffer() );
    }    
    fprintf( outFile, ";\n" );
  }
  fprintf( outFile, "\nend;\n" );
  fclose( outFile );
}

/////////////////////////////////////////////////////////////////////
void 
App::onOpen( FL_OBJECT *ob, long userData )
{
  App *app = ( App * ) userData;
  char *ptr = fl_show_fselector( "Open file", "./", "*.pat", "" );
  if ( ptr != NULL )
  {
    string fileName = ptr;
    app->onOpened( fileName );
    string title = "WaView - ";
    title += fileName;
    fl_set_form_title( app->mainWindow, title.getBuffer() );
    app->update();
  }
}

////////////////////////////////////////////////////////////////////
int
App::onOpened( string &fileName )
{
  char line[ 500 ], *tok, *temp;
 
  if ( fl_form_is_visible( mainWindow ) )
  {
    fl_set_cursor( mainWindow->window, XC_watch );
    XFlush( fl_get_display() );
  }

  FILE *fp = fopen( fileName.getBuffer(), "r" );
  if ( !fp )
  {
    string message;
    message = "WaView: Cannot open file ";
    message += fileName;
    message += ".";
    fl_show_alert( message.getBuffer(), NULL, NULL, 1 );
    if ( fl_form_is_visible( mainWindow ) )
    {
      fl_set_cursor( mainWindow->window, XC_top_left_arrow );
      XFlush( fl_get_display() );
    }
    return 0;
  }

  // Free up signals if already allocated
  if ( numSignals > 0 )
  {
    for ( int i = 0; i < numSignals; i++ )
    {
      delete sig[ i ];
    }
    numSignals = 0;
  }
  numSamples = 0;

  // Find how many samples in file
  int count = 0;
  while ( fgets( line, 500, fp ) )
  {
    tok = strtok( line, " \n" );
    if ( tok && strstr( tok, "begin" ) )
      break;
    if ( ++count == 500 )
    {
      string message;
      message = "WaView: File ";
      message += fileName;
      message += " is probably not a pat file.";
      fl_show_alert( message.getBuffer(), NULL, NULL, 1 );
      if ( fl_form_is_visible( mainWindow ) )
      {
	fl_set_cursor( mainWindow->window, XC_top_left_arrow );
	XFlush( fl_get_display() );
      }
      return 0;
    }
  }
    
  while ( fgets( line, 500, fp ) )
  {
    tok = strtok( line, " \n" );
    if ( tok && !strstr( tok, "--" ) && strcmp( tok, ":" ) == 0 )
      numSamples++;
    else
    {
      tok = strtok( NULL, " \n" );
      if ( tok && strcmp( tok, ":" ) == 0 )
	numSamples++;
    }      
  }
  fseek( fp, 0L, SEEK_SET );

  // Read file data  
  char name[ 100 ];   
  int top, bottom;
  int width, type;
  do
  {
    if ( fgets( line, 500, fp ) == NULL )
    {
      string message = "WaView: Error loading file ";
      message += fileName;
      message += ".";
      fl_show_alert( message.getBuffer(), NULL, NULL, 1 );
      if ( fl_form_is_visible( mainWindow ) )
      {
	fl_set_cursor( mainWindow->window, XC_top_left_arrow );
	XFlush( fl_get_display() );
      }
      return 0;
    }
    temp = strtok( line, " " );
    // Line has a signal definition
    if ( temp && strstr( temp, "begin" ) )
      break;
    else if ( strcmp( temp, "in" ) == 0 || strcmp( temp, "out" ) == 0 || 
	      strcmp( temp, "inout" ) == 0 || 
	      strcmp( temp, "register" ) == 0 ||
	      strcmp( temp, "signal" ) == 0 )
    {
      // Get signal name
      temp = strtok( NULL, " \n" );
      strcpy( name, temp );
      
      temp = strtok( NULL, " \n" );
      // Is this a signal or a bus?
      if ( strstr( temp, "(" ) )
      {
	sscanf( temp, "(%d", &top );
	temp = strtok( NULL, " \n" );
	temp = strtok( NULL, " \n" );
	sscanf( temp, "%d)", &bottom );
	width = top + 1 - bottom;
	temp = strtok( NULL, " \n" );
	if ( strstr( temp, "B" ) )
	  type = BIN;
	else if ( strstr( temp, "O" ) )
	  type = OCT;
	else if ( strstr( temp, "D" ) )
	  type = DEC;
	else if ( strstr( temp, "X" ) )
	  type = HEX;	
      }
      else
      {
	width = 1;
	// Get signal type
	if ( strcmp( temp, "B" ) )
	  type = BIN;
	else if ( strstr( temp, "O" ) )
	  type = OCT;
	else if ( strstr( temp, "D" ) )
	  type = DEC;
	else if ( strstr( temp, "X" ) )
	  type = HEX;	
      }
      if ( width > 32 )
      {
	deleteContents();
	string mesg1, mesg2;
	mesg1 = "WaView: Error loading file ";
	mesg1 += fileName;
	mesg2 = "Waview does not support signals wider than 32 bits!";
	fl_show_alert( mesg1.getBuffer(), mesg2.getBuffer(), NULL, 1 );
	if ( fl_form_is_visible( mainWindow ) )
	{
	  fl_set_cursor( mainWindow->window, XC_top_left_arrow );
	  XFlush( fl_get_display() );
	}
	return 0;
      }
      sig[ numSignals++ ] = new Bus( name, width, type, numSamples );
    }
    else
      continue;
  } while ( 1 );
  
  fseek( fp, 0L, SEEK_SET );
  int lin = 0;
  while ( fgets( line, 500, fp ) )
  {
    lin++;
    tok = strtok( line, " \n" );
    if ( tok && strstr( tok, "begin" ) )
    {
      break;
    }
  }
  // Get signal data
  while ( fgets( line, 500, fp ) )
  {
    char lineNumStr[ 10 ];
    sprintf( lineNumStr, "%d", ++lin );

    if ( strlen( line ) < 10 || line[ 0 ] == '-' )
      continue;

    tok = strtok( line, " " );
    if ( tok == NULL || strstr( tok, "--" ) )
      continue;
    if ( strstr( tok, "end" ) ) 
      break;

    // If line has a label => get next token
    if ( strcmp( tok, ":" ) != 0 )
    {
      tok = strtok( NULL, " " );
    }
    for ( int i = 0; i < numSignals; i++ )
    {
      int vv;
      char vvStr[ 9 ];
      tok = strtok( NULL, " " );
      if ( tok == NULL )
      {
	deleteContents();
	string mesg1, mesg2;
	mesg1 = "WaView: Error loading file ";
	mesg1 += fileName;
	mesg2 = "Incorrect number of arguments in line ";
	mesg2 += lineNumStr;
	mesg2 += " !";
	fl_show_alert( mesg1.getBuffer(), mesg2.getBuffer(), NULL, 1 );
	if ( fl_form_is_visible( mainWindow ) )
	{
	  fl_set_cursor( mainWindow->window, XC_top_left_arrow );
	  XFlush( fl_get_display() );
	}
	return 0;
      }
      if ( tok[ 0 ] == ';' )
      {
	deleteContents();
	string mesg1, mesg2;
	mesg1 = "WaView: Error loading file ";
	mesg1 += fileName;
	mesg2 = "Unexpected ';' in line ";
	mesg2 += lineNumStr;
	mesg2 += " !";
	fl_show_alert( mesg1.getBuffer(), mesg2.getBuffer(), NULL, 1 );
	if ( fl_form_is_visible( mainWindow ) )
	{
	  fl_set_cursor( mainWindow->window, XC_top_left_arrow );
	  XFlush( fl_get_display() );
	}
	return 0;
      }
      switch ( sig[ i ]->getType() )
      {
      case BIN :
      case DEC :
	if ( strstr( tok, "?" ) )
	  strcpy( vvStr, "?%d" );
	else 
	  strcpy( vvStr, "%d" );	  
	break;
      case OCT :
	if ( strstr( tok, "?" ) )
	  strcpy( vvStr, "?%o" );
	else 
	  strcpy( vvStr, "%o" );
	break;
      case HEX :
	if ( strstr( tok, "?" ) )
	  strcpy( vvStr, "?%x" );
	else 
	  strcpy( vvStr, "%x" );
	break;
      }
      sscanf( tok, vvStr, &vv );
      sig[ i ]->set( vv );
    }
  }

  // If type is specified as non Default ( not 0 ) in ini file 
  // then overwrite the type
  if ( iniStruct.DefaultRadix != 0 )
  {
    for ( int i = 0; i < numSignals; i++ )
      sig[ i ]->setType( iniStruct.DefaultRadix );
  }

  // Set span length
  if ( ( canvas->w - sigNameWidth ) >= numSamples )
  {
    spanLength = ( int ) ( ( ( float ) canvas->w - ( float ) sigNameWidth ) / 
      ( ( float ) numSamples ) );
  }
  else
    spanLength = 1;

  selectedSignal = -1;

  if ( fl_form_is_visible( mainWindow ) )
  {
    fl_set_cursor( mainWindow->window, XC_top_left_arrow );
    XFlush( fl_get_display() );
  }

  // Enable menus
  fl_set_menu_item_mode( fileMenu, 2, FL_PUP_NONE );
  fl_set_menu_item_mode( fileMenu, 3, FL_PUP_NONE );
  fl_set_menu_item_mode( editMenu, 1, FL_PUP_GRAY );
  fl_set_menu_item_mode( editMenu, 2, FL_PUP_GRAY );
  fl_set_menu_item_mode( editMenu, 3, FL_PUP_GRAY );
  fl_set_menu_item_mode( editMenu, 5, FL_PUP_GRAY );
  fl_set_menu_item_mode( zoomMenu, 1, FL_PUP_NONE );
  fl_set_menu_item_mode( zoomMenu, 2, FL_PUP_NONE );
  fl_set_menu_item_mode( zoomMenu, 3, FL_PUP_NONE );
  fl_set_menu_item_mode( zoomMenu, 4, FL_PUP_NONE );

  resetScrollBars();
  return 1;
}

void 
App::onCut( FL_OBJECT *ob, long userData )
{
  App *app = ( App * ) userData;
  if ( app->selectedSignal == -1 )
    return;

  if ( app->tempCopySig )
    delete app->tempCopySig;
  if ( app->tempCutSig )
    delete app->tempCutSig;
  app->tempCutSig = new Bus ( *app->sig[ app->selectedSignal ] );
  app->removeSignal( app->selectedSignal );
  app->numSignals--;
  app->resetScrollBars();
  fl_set_menu_item_mode( app->editMenu, 1, FL_PUP_GRAY );
  fl_set_menu_item_mode( app->editMenu, 2, FL_PUP_GRAY );
  fl_set_menu_item_mode( app->editMenu, 3, FL_PUP_NONE );
  fl_set_menu_item_mode( app->editMenu, 5, FL_PUP_GRAY );
  app->update();
}

void 
App::onCopy( FL_OBJECT *ob, long userData )
{
  App *app = ( App * ) userData;
  if ( app->selectedSignal == -1 )
    return;
  if ( app->tempCopySig )
    delete app->tempCopySig;
  if ( app->tempCutSig )
    delete app->tempCutSig;
  app->tempCopySig = new Bus ( *app->sig[ app->selectedSignal ] );
}

void 
App::onPaste( FL_OBJECT *ob, long userData )
{
  App *app = ( App * ) userData;
  if ( !app->tempCopySig && !app->tempCutSig || app->selectedSignal == -1 )
    return;
  app->addSignal( app->selectedSignal );
  app->numSignals++;
  app->resetScrollBars();
  app->update();
}

void 
App::removeSignal( int index )
{
  for ( int i = index; i < numSignals - 1; i++ )
    sig[ i ] = sig[ i + 1 ];
}

void 
App::addSignal( int index )
{
  if ( index == numSignals - 1 )
  {
    if ( tempCutSig )
      sig[ index + 1 ] = tempCutSig;
    else
      sig[ index + 1 ] = tempCopySig;
  }
  else
  {
    for ( int i = numSignals; i > index + 1; i-- )
      sig[ i ] = sig[ i - 1 ];
    if ( tempCutSig )
      sig[ index + 1 ] = tempCutSig;
    else
      sig[ index + 1 ] = tempCopySig;
  }
  tempCutSig = tempCopySig = NULL;
}

void 
App::onProgProperties( FL_OBJECT *ob, long userData )
{
  App *app = ( App * ) userData;
  app->progPropForm->show( app->sig, app->numSignals, app->colors );
}

void 
App::onProperties( FL_OBJECT *ob, long userData )
{
  App *app = ( App * ) userData;
  if ( app->selectedSignal > -1 )
    app->propForm->show( app->selectedSignal, app->sig );
}

void 
App::onAbout()
{
  aboutForm->show();
}

void 
App::onMenu( FL_OBJECT *ob, long userData )
{
  App *app = ( App * ) userData;
  if ( strcmp( fl_get_menu_text( ob ), "Open File..." ) == 0 )
  {
    fl_call_object_callback( app->openButton );
  }
  else if ( strcmp( fl_get_menu_text( ob ), "Save File..." ) == 0 )
  {
    fl_call_object_callback( app->saveButton );
  }
  else if ( strcmp( fl_get_menu_text( ob ), "Write Postscript..." ) == 0 )
  {
    app->onPrint();
  }
  else if ( strcmp( fl_get_menu_text( ob ), "Signal Properties..." ) == 0 )
  {
    fl_call_object_callback( app->propButton );
  }
  else if ( strcmp( fl_get_menu_text( ob ), "Program Properties..." ) == 0 )
  {
    fl_call_object_callback( app->progPropButton );
  }
  else if ( strcmp( fl_get_menu_text( ob ), "Last" ) == 0 )
  {
    int temp1 = app->startSample;
    int temp2 = app->spanLength;

    app->startSample = app->lastStartSample;
    app->spanLength = app->lastSpanLength;

    app->lastStartSample = temp1;
    app->lastSpanLength = temp2;
    // Figure out cursor position
    int mod = ( app->cursorPos1 - app->sigNameWidth ) % app->spanLength;
    if ( mod )
    {
      if ( mod > ( app->spanLength >> 1 ) )
	app->cursorPos1 = app->cursorPos1 - mod + app->spanLength;
      else
	app->cursorPos1 = app->cursorPos1 - mod;
    }
      
    app->resetScrollBars();
    app->update();
  }
  else if ( strcmp( fl_get_menu_text( ob ), "Full" ) == 0 )
  {
    app->lastStartSample = app->startSample;
    app->lastSpanLength = app->spanLength;

    if ( ( app->canvas->w - app->sigNameWidth ) >= app->numSamples )
    {
      app->spanLength = ( int ) ( ( ( float ) app->canvas->w - 
			( float ) app->sigNameWidth ) / 
                        ( float ) app->numSamples );
    }
    else
      app->spanLength = 1;    
    app->startSample = 0;
    app->selectedSample = ( app->cursorPos1 - app->sigNameWidth ) / 
                          app->spanLength + app->startSample;
    app->resetScrollBars();
    app->update();
  }
  else if ( strcmp( fl_get_menu_text( ob ), "In x2" ) == 0 )
  {
    app->lastStartSample = app->startSample;
    app->lastSpanLength = app->spanLength;
    app->spanLength *= 2;    
    if ( app->spanLength > app->canvas->w - app->sigNameWidth )
      app->spanLength = app->canvas->w - app->sigNameWidth;
    app->selectedSample = ( app->cursorPos1 - app->sigNameWidth ) 
                          / app->spanLength + app->startSample;
    app->resetScrollBars();
    app->update();
  }
  else if ( strcmp( fl_get_menu_text( ob ), "Out x2" ) == 0 )
  {
    app->lastStartSample = app->startSample;
    app->lastSpanLength = app->spanLength;
    if ( app->spanLength >= 2 )
      app->spanLength /= 2;    
    app->selectedSample = ( app->cursorPos1 - app->sigNameWidth ) / 
                          app->spanLength + app->startSample;
    app->resetScrollBars();
    app->update();
  }
  else if ( strcmp( fl_get_menu_text( ob ), "About" ) == 0 )
  {    
    app->onAbout();
  }
  else if ( strcmp( fl_get_menu_text( ob ), "Cut" ) == 0 )
  {
    fl_call_object_callback( app->cutButton );
  }
  else if ( strcmp( fl_get_menu_text( ob ), "Copy" ) == 0 )
  {
    fl_call_object_callback( app->copyButton );
  }
  else if ( strcmp( fl_get_menu_text( ob ), "Paste" ) == 0 )
  {
    fl_call_object_callback( app->pasteButton );
  }
  else if ( strcmp( fl_get_menu_text( ob ), "Exit" ) == 0 )
  {  
    if ( fl_show_question( "Quit Program?", 1 ) )
    {
      fl_hide_form( app->mainWindow );
      fl_free_form( app->mainWindow );
      XFreePixmap( fl_get_display(), app->dBuffer );
      exit( 0 );
    } 
  }
}

////////////////////////////////////////////////////////////////////
AboutForm::AboutForm( App *pApp ) : parent( pApp )
{
  FL_OBJECT *obj;
  string ver = "$Revision: 1.18 $";
  string tok = strtok( ver.getBuffer(), " " );
  tok = strtok( NULL, " " );
  string title = "WaView ";
  title += tok;

  mainWindow = fl_bgn_form( FL_NO_BOX, 350, 160 );   
  fl_add_box( FL_UP_BOX, 0, 0, 350, 160, NULL );

  obj = fl_add_text( FL_NORMAL_TEXT, 110, 20, 200, 20, title.getBuffer() );
  fl_set_object_lsize( obj, FL_LARGE_SIZE );
  obj = fl_add_text( FL_NORMAL_TEXT, 60, 50, 250, 20, 
		     "Written By: Marcos Zini (mzini01@icanect.net)" );
  obj = fl_add_text( FL_NORMAL_TEXT, 75, 65, 250, 20, 
		     "and Javier Conde (jconde@lceent.com)" );
  okButton = fl_add_button( FL_RETURN_BUTTON, 130, 100, 80, 30, "Ok" );
  fl_set_object_callback( okButton, onOk, ( long ) this );
  fl_set_object_shortcut( okButton, "Oo#O#o", 1 );
  fl_end_form();
}

void 
AboutForm::onOk( FL_OBJECT *ob, long userData )
{
  AboutForm *diag = ( AboutForm * ) userData;
  fl_hide_form( diag->mainWindow );
}

void
AboutForm::show()
{
  fl_show_form( mainWindow, FL_PLACE_CENTER, FL_TRANSIENT, "About Waview" ); 
}

///////////////////////////////////////////////////////////////////////////
SignalTypeForm::SignalTypeForm( App *pApp ) : parent( pApp )
{
  FL_OBJECT *obj;

  mainWindow = fl_bgn_form( FL_NO_BOX, 290, 190 );

  fl_set_border_width( -2 );
  obj = fl_add_box( FL_UP_BOX, 0, 0, 290, 190, "" );
  obj = fl_add_text( FL_NORMAL_TEXT, 20, 10, 100, 20, "Signal Name:" );
  fl_set_object_lalign( obj, FL_ALIGN_LEFT | FL_ALIGN_INSIDE );
  typeChoice = fl_add_choice( FL_NORMAL_CHOICE2, 20, 90, 90, 30, "" );
  fl_set_object_callback( typeChoice, onChoice, ( long ) this );
  fl_addto_choice( typeChoice, "Binary|Octal|Decimal|Hexadecimal" );
  fl_set_choice( typeChoice, 1 );
  nameText = fl_add_input( FL_NORMAL_INPUT, 20, 30, 210, 30, "" );
  obj = fl_add_text( FL_NORMAL_TEXT, 20, 70, 80, 20, "Signal Type:" );
  fl_set_object_lalign( obj, FL_ALIGN_LEFT | FL_ALIGN_INSIDE );
  okButton = fl_add_button( FL_RETURN_BUTTON, 20, 140, 70, 30, "OK");
  fl_set_object_callback( okButton, onOK, ( long ) this );
  fl_set_object_shortcut( okButton, "Oo#O#o", 1 );
  applyButton = fl_add_button( FL_NORMAL_BUTTON, 110, 140, 70, 30, "Apply");
  fl_set_object_callback( applyButton, onApply, ( long ) this );
  fl_set_object_shortcut( applyButton, "Aa#A#a", 1 );
  cancelButton = fl_add_button( FL_NORMAL_BUTTON, 200, 140, 70, 30, "Cancel");
  fl_set_object_callback( cancelButton, onCancel, ( long ) this );
  fl_set_object_shortcut( cancelButton, "Cc#C#c", 1 );

  fl_end_form();
}

void 
SignalTypeForm::show( int i, Bus **pBus )
{ 
  bus = pBus;

  sel = i;
  switch ( bus[ i ]->getType() )
  {
  case BIN :
    fl_set_choice( typeChoice, 1 );
    break;
  case OCT :
    fl_set_choice( typeChoice, 2 );
    break;
  case DEC :
    fl_set_choice( typeChoice, 3 );
    break;
  case HEX :
    fl_set_choice( typeChoice, 4 );
    break;
  }
  fl_set_input( nameText, bus[ i ]->getName().getBuffer() );
  fl_show_form( mainWindow, FL_PLACE_CENTER, 
		FL_TRANSIENT, "Signal Properties" ); 
}

void 
SignalTypeForm::setSelected( int i )
{ 
  if ( isVisible() )
  {
    sel = i;
    fl_set_input( nameText, bus[ i ]->getName().getBuffer() ); 
    
    switch ( bus[ i ]->getType() )
    {
    case BIN :
      fl_set_choice( typeChoice, 1 );
      break;
    case OCT :
      fl_set_choice( typeChoice, 2 );
      break;
    case DEC :
      fl_set_choice( typeChoice, 3 );
      break;
    case HEX :
      fl_set_choice( typeChoice, 4 );
      break;
    }
  }
}

void 
SignalTypeForm::onOK( FL_OBJECT *ob, long userData )
{
  SignalTypeForm *diag = ( SignalTypeForm * ) userData;
  
  diag->bus[ diag->sel ]->setName( fl_get_input( diag->nameText ) );

  switch ( fl_get_choice( diag->typeChoice ) )
  {
  case 1 :
    diag->bus[ diag->sel ]->setType( BIN );
    break;
  case 2 :
    diag->bus[ diag->sel ]->setType( OCT );
    break;
  case 3 :
    diag->bus[ diag->sel ]->setType( DEC );
    break;
  case 4 :
    diag->bus[ diag->sel ]->setType( HEX );
    break;
  }
  fl_hide_form( diag->mainWindow );
  diag->parent->update();
}

void 
SignalTypeForm::onApply( FL_OBJECT *ob, long userData )
{
  SignalTypeForm *diag = ( SignalTypeForm * ) userData;
  
  diag->bus[ diag->sel ]->setName( fl_get_input( diag->nameText ) );

  switch ( fl_get_choice( diag->typeChoice ) )
  {
  case 1 :
    diag->bus[ diag->sel ]->setType( BIN );
    break;
  case 2 :
    diag->bus[ diag->sel ]->setType( OCT );
    break;
  case 3 :
    diag->bus[ diag->sel ]->setType( DEC );
    break;
  case 4 :
    diag->bus[ diag->sel ]->setType( HEX );
    break;
  }
  diag->parent->update();
}


void 
SignalTypeForm::onCancel( FL_OBJECT *ob, long userData )
{
  SignalTypeForm *diag = ( SignalTypeForm * ) userData;

  fl_hide_form( diag->mainWindow );
}

///////////////////////////////////////////////////////////////////////////
ColorSelectionForm::ColorSelectionForm( ProgramPropertiesForm *pParent ) :
  parent( pParent )
{
  FL_OBJECT *obj;

  mainWindow = fl_bgn_form( FL_NO_BOX, 290, 190 );

  fl_set_border_width( -2 );
  obj = fl_add_box( FL_UP_BOX, 0, 0, 290, 190, "" );

  obj = fl_add_text( FL_NORMAL_TEXT, 20, 20, 80, 20, "Red:" );
  redSlider = fl_add_valslider( FL_HOR_SLIDER, 60, 20, 140, 20, "" );
  fl_set_object_callback( redSlider, onRedSlide, ( long ) this );

  obj = fl_add_text( FL_NORMAL_TEXT, 20, 60, 80, 20, "Green:" );
  greenSlider = fl_add_valslider( FL_HOR_SLIDER, 60, 60, 140, 20, "" );
  fl_set_object_callback( greenSlider, onGreenSlide, ( long ) this );

  obj = fl_add_text( FL_NORMAL_TEXT, 20, 100, 80, 20, "Blue:" );
  blueSlider = fl_add_valslider( FL_HOR_SLIDER, 60, 100, 140, 20, "" );
  fl_set_object_callback( blueSlider, onBlueSlide, ( long ) this );

  okButton = fl_add_button( FL_RETURN_BUTTON, 65, 140, 70, 30, "OK" );
  fl_set_object_callback( okButton, onOK, ( long ) this );
  fl_set_object_shortcut( okButton, "Oo#O#o", 1 );
  cancelButton = fl_add_button( FL_NORMAL_BUTTON, 155, 140, 70, 30, "Cancel" );
  fl_set_object_callback( cancelButton, onCancel, ( long ) this );
  fl_set_object_shortcut( cancelButton, "Cc#C#c", 1 );

  canvas = fl_add_canvas( FL_SCROLLED_CANVAS, 215, 20, 50, 60, "" );
  fl_set_object_callback( canvas, onPaint, ( long ) this );
  fl_add_canvas_handler( canvas, Expose, onPaint, this );

  fl_end_form();
}

void 
ColorSelectionForm::onPaint()
{
  GC gc = fl_state[ fl_get_vclass() ].gc[ 1 ];
  Display *disp = fl_get_display();
  Window w = FL_ObjWin( canvas );
  XSetForeground( disp, gc, parent->colors[ 100 ].pixel );
  XFillRectangle( disp, w, gc, 0, 0, 50, 60 );
}

void 
ColorSelectionForm::show( int colIndex )
{ 
  colorIndex = colIndex;

  Display *disp = fl_get_display();
  Colormap colormap = DefaultColormap( disp, DefaultScreen( disp ) );
  parent->colors[ 100 ] = parent->colors[ colorIndex ];
  XAllocColor( disp, colormap, &parent->colors[ colorIndex ] );

  double red = ( double ) parent->colors[ 100 ].red / ( double ) 0xFFFF;
  fl_set_slider_value( redSlider, red );
  double green = ( double ) parent->colors[ 100 ].green / ( double ) 0xFFFF;
  fl_set_slider_value( redSlider, red );
  double blue = ( double ) parent->colors[ 100 ].blue / ( double ) 0xFFFF;
  fl_set_slider_value( redSlider, red );
  fl_set_slider_value( greenSlider, green );
  fl_set_slider_value( blueSlider, blue );
  fl_show_form( mainWindow, FL_PLACE_CENTER, 
		FL_TRANSIENT, "Color Properties" );
}

void
ColorSelectionForm::onRedSlide( FL_OBJECT *ob, long userData )
{
  ColorSelectionForm *diag = ( ColorSelectionForm * ) userData;
  diag->parent->colors[ 100 ].red = ( unsigned short ) 
    ( fl_get_slider_value( diag->redSlider ) * ( double ) 0xFFFF );

  Display *disp = fl_get_display();
  Colormap colormap = DefaultColormap( disp, DefaultScreen( disp ) );
  XAllocColor( disp, colormap, &diag->parent->colors[ 100 ] );
  diag->update();
}

void
ColorSelectionForm::onGreenSlide( FL_OBJECT *ob, long userData )
{
  ColorSelectionForm *diag = ( ColorSelectionForm * ) userData;
  diag->parent->colors[ 100 ].green = ( unsigned short ) 
    ( fl_get_slider_value( diag->greenSlider ) * ( double ) 0xFFFF );

  Display *disp = fl_get_display();
  Colormap colormap = DefaultColormap( disp, DefaultScreen( disp ) );
  XAllocColor( disp, colormap, &diag->parent->colors[ 100 ] );
  diag->update();
}

void
ColorSelectionForm::onBlueSlide( FL_OBJECT *ob, long userData )
{
  ColorSelectionForm *diag = ( ColorSelectionForm * ) userData;
  diag->parent->colors[ 100 ].blue = ( unsigned short ) 
    ( fl_get_slider_value( diag->blueSlider ) * ( double ) 0xFFFF );

  Display *disp = fl_get_display();
  Colormap colormap = DefaultColormap( disp, DefaultScreen( disp ) );
  XAllocColor( disp, colormap, &diag->parent->colors[ 100 ] );
  diag->update();
}

void 
ColorSelectionForm::onOK( FL_OBJECT *ob, long userData )
{
  ColorSelectionForm *diag = ( ColorSelectionForm * ) userData;

  Display *disp = fl_get_display();

  Colormap colormap = DefaultColormap( disp, DefaultScreen( disp ) );
  diag->parent->colors[ diag->colorIndex ] = diag->parent->colors[ 100 ];
  XAllocColor( disp, colormap, &diag->parent->colors[ diag->colorIndex ] );
  
  fl_hide_form( diag->mainWindow );
  diag->parent->parent->update();
}

void 
ColorSelectionForm::onCancel( FL_OBJECT *ob, long userData )
{
  ColorSelectionForm *diag = ( ColorSelectionForm * ) userData;
  fl_hide_form( diag->mainWindow );
}

///////////////////////////////////////////////////////////////////////////
ProgramPropertiesForm::ProgramPropertiesForm( App *pApp ) : parent( pApp )
{
  FL_OBJECT *obj;

  colorForm = new ColorSelectionForm( this );

  fl_set_border_width( -2 );
  mainWindow = fl_bgn_form( FL_NO_BOX, 370, 230 );

  obj = fl_add_box( FL_UP_BOX, 0, 0, 370, 230, "" );

  //
  obj = fl_add_labelframe( FL_ENGRAVED_FRAME, 20, 20, 130, 145, 
			   "General" );

  hierarchyButton = fl_add_checkbutton( FL_PUSH_BUTTON, 30, 35, 100, 20, 
					"Display Hierarchy" );
  fl_set_button( hierarchyButton, parent->iniStruct.DisplayHierarchy );
  fl_set_object_callback( hierarchyButton, onHierarchy, ( long ) this );

  tipsButton = fl_add_checkbutton( FL_PUSH_BUTTON, 30, 65, 100, 20, 
				   "Enable Tips" );
  fl_set_button( tipsButton, parent->iniStruct.EnableTips );
  fl_set_object_callback( tipsButton, onTips, ( long ) this );

  obj = fl_add_text( FL_NORMAL_TEXT, 30, 95, 80, 20, "Signal Type:" );
  typeChoice = fl_add_choice( FL_NORMAL_CHOICE2, 35, 115, 90, 30, "" );
  fl_set_object_callback( typeChoice, onChoice, ( long ) this );
  fl_addto_choice( typeChoice, "Binary|Octal|Decimal|Hexadecimal" );
  fl_set_choice( typeChoice, 1 );

  //
  obj = fl_add_labelframe( FL_ENGRAVED_FRAME, 170, 20, 180, 145, 
			   "Color" );
  
  obj = fl_add_text( FL_NORMAL_TEXT, 180, 35, 100, 20, "Color Component:" );
  colorBrowser = fl_add_browser( FL_HOLD_BROWSER, 185, 55, 80, 90, "" );
  fl_set_object_callback( colorBrowser, onColorBrowser, ( long ) this );
  fl_add_browser_line( colorBrowser, "Signal" );
  fl_add_browser_line( colorBrowser, "Bus" );
  fl_add_browser_line( colorBrowser, "Font" );
  fl_add_browser_line( colorBrowser, "Cursor" );
  fl_add_browser_line( colorBrowser, "Background" );
  colorButton = fl_add_button( FL_NORMAL_BUTTON, 275, 55, 60, 30, "Modify" );
  fl_set_object_lcol( colorButton, FL_INACTIVE_COL );
  fl_set_object_callback( colorButton, onModifyColor, ( long ) this );
  fl_deactivate_object( colorButton );

  okButton = fl_add_button( FL_RETURN_BUTTON, 60, 180, 70, 30, "OK");
  fl_set_object_callback( okButton, onOK, ( long ) this );
  fl_set_object_shortcut( okButton, "Oo#O#o", 1 );
  applyButton = fl_add_button( FL_NORMAL_BUTTON, 150, 180, 70, 30, "Apply");
  fl_set_object_callback( applyButton, onApply, ( long ) this );
  fl_set_object_shortcut( applyButton, "Aa#A#a", 1 );
  cancelButton = fl_add_button( FL_NORMAL_BUTTON, 240, 180, 70, 30, "Cancel");
  fl_set_object_callback( cancelButton, onCancel, ( long ) this );
  fl_set_object_shortcut( cancelButton, "Cc#C#c", 1 );

  fl_end_form();
}

void 
ProgramPropertiesForm::onModifyColor( FL_OBJECT *ob, long userData )
{
  ProgramPropertiesForm *diag = ( ProgramPropertiesForm * ) userData;

  switch ( fl_get_browser( diag->colorBrowser ) )
  {
  case 1 :
    diag->colorForm->show( SIGNAL );
    break;
  case 2 :
    diag->colorForm->show( BUS );
    break;
  case 3 :
    diag->colorForm->show( FONT );
    break;
  case 4 :
    diag->colorForm->show( CURSOR );
    break;
  case 5 :
    diag->colorForm->show( BACKGROUND );
    break;
  }
}

void 
ProgramPropertiesForm::onColorBrowser( FL_OBJECT *ob, long userData )
{
  ProgramPropertiesForm *diag = ( ProgramPropertiesForm * ) userData;
  fl_activate_object( diag->colorButton );
  fl_set_object_lcol( diag->colorButton, FL_BLACK );
}

void 
ProgramPropertiesForm::show( Bus **pBus, int valid, XColor *cols )
{
  bus = pBus;
  validSignals = valid;
  colors = cols;

  fl_show_form( mainWindow, FL_PLACE_CENTER, 
		FL_TRANSIENT, "Program Properties" ); 
  switch ( parent->iniStruct.DefaultRadix )
  {
  case BIN :
    fl_set_choice( typeChoice, 1 );
    break;
  case OCT :
    fl_set_choice( typeChoice, 2 );
    break;
  case DEC :
    fl_set_choice( typeChoice, 3 );
    break;
  case HEX :
    fl_set_choice( typeChoice, 4 );
    break;
  }
}

void 
ProgramPropertiesForm::setSelected( int i )
{ 
  if ( isVisible() )
  {
  }
}

void 
ProgramPropertiesForm::onOK( FL_OBJECT *ob, long userData )
{
  ProgramPropertiesForm *diag = ( ProgramPropertiesForm * ) userData;
  int i;
  
  diag->parent->iniStruct.DisplayHierarchy = fl_get_button( diag->hierarchyButton );
  diag->parent->iniStruct.EnableTips = fl_get_button( diag->tipsButton );
  set_tip( diag->parent->openButton, "Open File", diag->parent->iniStruct.EnableTips );
  set_tip( diag->parent->saveButton, "Save File", diag->parent->iniStruct.EnableTips );
  set_tip( diag->parent->propButton, "Signal Properties", 
	   diag->parent->iniStruct.EnableTips );
  set_tip( diag->parent->progPropButton, "Program Properties", 
	   diag->parent->iniStruct.EnableTips );
  set_tip( diag->parent->copyButton, "Copy", diag->parent->iniStruct.EnableTips );
  set_tip( diag->parent->cutButton, "Cut", diag->parent->iniStruct.EnableTips );
  set_tip( diag->parent->pasteButton ,"Paste", diag->parent->iniStruct.EnableTips );

  switch ( fl_get_choice( diag->typeChoice ) )
  {
  case 1 :
    for ( i = 0; i < diag->validSignals; i++ )
      diag->parent->sig[ i ]->setType( BIN );
    diag->parent->iniStruct.DefaultRadix = BIN;
    break;
  case 2 :
    for ( i = 0; i < diag->validSignals; i++ )
      diag->parent->sig[ i ]->setType( OCT );
    diag->parent->iniStruct.DefaultRadix = OCT;
    break;
  case 3 :
    for ( i = 0; i < diag->validSignals; i++ )
      diag->parent->sig[ i ]->setType( DEC );
    diag->parent->iniStruct.DefaultRadix = DEC;
    break;
  case 4 :
    for ( i = 0; i < diag->validSignals; i++ )
      diag->parent->sig[ i ]->setType( HEX );
    diag->parent->iniStruct.DefaultRadix = HEX;
    break;
  }
  fl_hide_form( diag->mainWindow );
  diag->parent->update();
}

void 
ProgramPropertiesForm::onApply( FL_OBJECT *ob, long userData )
{
  ProgramPropertiesForm *diag = ( ProgramPropertiesForm * ) userData;
  int i;

  diag->parent->iniStruct.DisplayHierarchy = fl_get_button( diag->hierarchyButton );
  diag->parent->iniStruct.EnableTips = fl_get_button( diag->tipsButton );
  set_tip( diag->parent->openButton, "Open File", diag->parent->iniStruct.EnableTips );
  set_tip( diag->parent->saveButton, "Save File", diag->parent->iniStruct.EnableTips );
  set_tip( diag->parent->propButton, "Signal Properties", 
	   diag->parent->iniStruct.EnableTips );
  set_tip( diag->parent->progPropButton, "Program Properties", 
	   diag->parent->iniStruct.EnableTips );
  set_tip( diag->parent->copyButton, "Copy", diag->parent->iniStruct.EnableTips );
  set_tip( diag->parent->cutButton, "Cut", diag->parent->iniStruct.EnableTips );
  set_tip( diag->parent->pasteButton ,"Paste", diag->parent->iniStruct.EnableTips );
  
  switch ( fl_get_choice( diag->typeChoice ) )
  {
  case 1 :
    for ( i = 0; i < diag->validSignals; i++ )
      diag->parent->sig[ i ]->setType( BIN );
    break;
    diag->parent->iniStruct.DefaultRadix = BIN;
  case 2 :
    for ( i = 0; i < diag->validSignals; i++ )
      diag->parent->sig[ i ]->setType( OCT );
    break;
    diag->parent->iniStruct.DefaultRadix = OCT;
  case 3 :
    for ( i = 0; i < diag->validSignals; i++ )
      diag->parent->sig[ i ]->setType( DEC );
    break;
    diag->parent->iniStruct.DefaultRadix = DEC;
  case 4 :
    for ( i = 0; i < diag->validSignals; i++ )
      diag->parent->sig[ i ]->setType( HEX );
    break;
    diag->parent->iniStruct.DefaultRadix = HEX;
  }
  diag->parent->update();
}


void 
ProgramPropertiesForm::onCancel( FL_OBJECT *ob, long userData )
{
  ProgramPropertiesForm *diag = ( ProgramPropertiesForm * ) userData;

  fl_hide_form( diag->mainWindow );
}

////////////////////////////////////////////////////////////////////////
int 
post_handler( FL_OBJECT *ob, int event, FL_Coord mx, FL_Coord my, 
	      int key, void *xev )
{
  if( !ob->u_vdata )
    return 0;

  if( event == FL_ENTER ) 
    timeoutID = fl_add_timeout( INTERVAL, do_tips, ob );
  else if( event == FL_LEAVE || event == FL_PUSH ) 
  {
    fl_hide_oneliner();
    if( timeoutID )
    {
      fl_remove_timeout( timeoutID );
      timeoutID = 0;
    }
  }
  return 0;
}

void
set_tip( FL_OBJECT *ob, char *s, int enable )
{
    ob->u_vdata = s;
    if ( enable )
      fl_set_object_posthandler( ob, post_handler );
    else
      fl_set_object_posthandler( ob, NULL );
}

void
do_tips( int id, void *p )
{
   FL_OBJECT *ob = ( FL_OBJECT * ) p;

   fl_show_oneliner( ( char * ) ob->u_vdata, ob->form->x + ob->x, 
		     ob->form->y + ob->y + ob->h + 1 );
   timeoutID = fl_add_timeout( INTERVAL, do_tips, ob );
}

////////////////////////////////////////////////////////////////////////////////
int
main( int argc, char **argv )
{   
  App p( argc, argv );
  p.show( "WaView - untitled" );
  p.run();
  
  return 0;
}
 
